uses crt, dos, mn_abstr, mn_kazal;

type
  cas=record {cas za shranjevanje casa priklopa}
    leto, mesec, dan, ure, min, sek: integer;
  end;
  kUporabnik=^uporabnik;
  uporabnik=object (vsebina) {glej mn_abstr; tu objekt razsirjen za namene tega programa - uporabnik streznika za priklop na
                             internet}
    ime, geslo: string; {uporabnisko ime, geslo}
    casPriklopa: cas; {cas priklopa}
    procedure izpis (cas: boolean); {izpise podatke o uporabniku}
    function jeEnak (vs: kVsebina): boolean; virtual;
    function prepisi: kVsebina; virtual;
  end;
  kMnUporabP=^mnUporabP;
  mnUporabP=object (mnKazalci)                                               {glej mn_kazal; tu objekt razsirjen za namene ->}
    function dodaj (vs: kVsebina; preveri, iter: boolean): boolean; virtual; {tega programa - mnozica uporabnikov, ki so ->}
    function brisi (vs: kVsebina): boolean; virtual;                         {priklopljeni na straznik za dostop do interneta}
    procedure izpis; {izpise vse uporabnike}
  end;
  kMnUporabNP=^mnUporabNP;
  mnUporabNP=object (mnKazalci) {glej mn_kazal; tu objekt razsirjen za namene tega programa - mnozica uporabnikov, ki niso
                                priklopljeni na straznik za dostop do interneta}
    procedure izpis; {izpise vse uporabnike}
    procedure brisiVse (mn: kMnUporabP); {iz mn zbrise vse uporabnike, enake uporabnikom v tej mnozici}
  end;

procedure uporabnik.izpis (cas: boolean);
begin
  write ('Uporabnisko ime: ', ime); {ce cas=true, se izpise tudi cas priklopa na internet, sicer pa samo uporabnisko ime}
  if cas then writeln (', priklopljen od: ', casPriklopa.ure, ':', casPriklopa.min, ':', casPriklopa.sek, ', ',
    casPriklopa.dan, '. ', casPriklopa.mesec, '. ', casPriklopa.leto) else writeln;
end;

function uporabnik.jeEnak (vs: kVsebina): boolean;
begin
  if (ime=kUporabnik (vs)^.ime) and (geslo=kUporabnik (vs)^.geslo) then {primerjata se uporabnisko ime in geslo}
    jeEnak:=true else jeEnak:=false;
end;

function uporabnik.prepisi: kVsebina;
  var zac: kVsebina;
begin
  zac:=new (kUporabnik, vsKons);
  kUporabnik (zac)^.ime:=ime;
  kUporabnik (zac)^.geslo:=geslo;
  kUporabnik (zac)^.casPriklopa:=casPriklopa;
  prepisi:=zac;
end;

function mnUporabP.dodaj (vs: kVsebina; preveri, iter: boolean): boolean;
begin
  writeln ('Priklapljam ...'); {tu bi straznik izvedel priklop}
  dodaj:=mnKazalci.dodaj (vs, preveri, iter); {klice se metoda starsa za dodajanje v mnozico}
end;

function mnUporabP.brisi (vs: kVsebina): boolean;
begin
  writeln ('Odklapljam ...'); {tu bi straznik izvedel odklop}
  brisi:=mnKazalci.brisi (vs); {klice se metoda starsa za brisanje iz mnozice}
end;

procedure mnUporabP.izpis;
  var trenutni: kElKazalci;
begin
  trenutni:=prvi^.naslednji;
  while trenutni<>nil do begin
    kUporabnik (trenutni^.vsebina)^.izpis (true); {izpisejo se tudi casi priklopa}
    trenutni:=trenutni^.naslednji;
  end;
end;

procedure mnUporabNP.izpis;
  var trenutni: kElKazalci;
begin
  trenutni:=prvi^.naslednji;
  while trenutni<>nil do begin
    kUporabnik (trenutni^.vsebina)^.izpis (false); {casi preklopa se ne izpisejo}
    trenutni:=trenutni^.naslednji;
  end;
end;

procedure mnUporabNP.brisiVse (mn: kMnUporabP);
  var trenutni: kElKazalci;
begin
  trenutni:=prvi^.naslednji;
  while trenutni<>nil do begin
    mn^.brisi (trenutni^.vsebina);
    trenutni:=trenutni^.naslednji;
  end;
end;

procedure zdaj (var vred: cas); {v cas zapise trenutni cas}
  var
    ure, min, sek, leto, mesec, dan, x: word;
begin
  getTime (ure, min, sek, x);
  getDate (leto, mesec, dan, x);
  vred.ure:=ure;
  vred.min:=min;
  vred.sek:=sek;
  vred.leto:=leto;
  vred.mesec:=mesec;
  vred.dan:=dan;
end;

var
  izbira, n: integer; {izbira - izbira v meniju}
  vt1, vt2: mnUporabP; {vt1, vt2 - uporabniki na 1., 2. vstopni tocki}
  gesla, maloprid, mnUZac: mnUporabNP; {gesla - znani uporabniki, maloprid - uporabniki, ki so se priklopili na obe vstopni
                                       tocki}
  uZac: kUporabnik;
  vpis: string;
  datUporab: text; {datoteka z znanimi uporabniki}

begin
  izbira:=0;
  vt1.mnKons; {inicializacija mnozic}
  vt2.mnKons;
  gesla.mnKons;
  maloprid.mnKons;
  mnUZac.mnKons;
  vt1.naredi;
  vt2.naredi;
  gesla.naredi;
  maloprid.naredi;
  mnUZac.naredi;
  assign (datUporab, 'uporab.txt'); {branje uporabnikov iz datoteke}
  reset (datUporab);
  repeat
    readln (datUporab, vpis);
    if vpis [1]<>'.' then begin
      uZac:=new (kUporabnik, vsKons);
      uZac^.ime:='';
      uZac^.geslo:='';
      n:=1;
      while vpis [n]<>':' do begin {do dvopicja je uporabnisko ime}
        uZac^.ime:=uZac^.ime+vpis [n];
        inc (n);
      end;
      inc (n);
      while vpis [n]<>'.' do begin {od dvopicja do pike je geslo}
        uZac^.geslo:=uZac^.geslo+vpis [n];
        inc (n);
      end;
      gesla.dodaj (uZac, false, true);
    end;
  until vpis [1]='.'; {pika na zacetku vrste pomeni konec datoteke}
  repeat
    clrscr; {izpis menija}
    writeln ('Simulacija streznika za dostop do interneta, napisal Mitja Lustrek');
    writeln;
    writeln ('Na strezniku:');
    writeln ('1 - izpis priklopljenih na 1. vstopni tocki');
    writeln ('2 - izpis priklopljenih na 2. vstopni tocki');
    writeln ('3 - izpis malopridnezev');
    writeln ('4 - poisci in odstrani malopridneze');
    writeln;
    writeln ('Pri uporabniku:');
    writeln ('5 - priklop na 1. vstopno tocko');
    writeln ('6 - priklop na 2. vstopno tocko');
    writeln;
    writeln ('7 - izhod');
    writeln;
    write ('Izberi: ');
    readln (izbira);
    case izbira of
      1, 2: begin {izpis uporabnikov na 1. ali 2. vstopni tocki}
        clrscr;
        if izbira=1 then vt1.izpis else vt2.izpis;
        readln;
      end;
      3: begin {izpis uporabnikov na obeh vstopnih tockah}
        clrscr;
        writeln ('Trenutno priklopljeni na obeh vstopnih tockah:');
        mnUZac.presek (@vt1, @vt2, true);
        mnUZac.izpis;
        readln;
      end;
      4: begin {iskanje in odstranjevanje malopridnezev}
        clrscr;
        writeln ('Do zdaj priklopljeni na obeh vstopnih tockah:');
        mnUZac.presek (@vt1, @vt2, true); {poisce uporabnike, ki so na obeh vstopnih tockah}
        maloprid.unija (@maloprid, @mnUZac, true); {doda jih znanim malopridnezem}
        maloprid.izpis;
        mnUZac.brisiVse (@vt1); {odstrani jih z obeh vstopnih tock}
        mnUZac.brisiVse (@vt2);
        readln;
      end;
      5, 6: begin {priklop uporabnika na 1. ali 2. vstopno tocko}
        clrscr;
        uZac:=new (kUporabnik, vsKons);
        write ('Uporabnisko ime: ');
        readln (vpis);
        uZac^.ime:=vpis;
        write ('Geslo: ');
        readln (vpis);
        uZac^.geslo:=vpis;
        zdaj (uZac^.casPriklopa);
        if gesla.pripada (uZac, true) then {ce ima pravo uporabnisko ime in geslo}
          if izbira=5 then {priklop na 1. vstopno tocko}
            if not vt1.dodaj (uZac, true, true) then begin
              dispose (uZac, vsDest);
              write ('Priklop ni uspel.');
            end else write ('Priklop uspel.')
          else {priklop na 2. vstopno tocko}
            if not vt2.dodaj (uZac, true, true) then begin
              dispose (uZac, vsDest);
              write ('Priklop ni uspel.');
            end else write ('Priklop uspel.')
        else write ('Napacno uporabnisko ime ali geslo.');
        readln;
      end;
    end;
  until izbira=7;
  vt1.mnDest; {sprostitev spomina, ki so ga zasedale mnozice}
  vt2.mnDest;
  gesla.mnDest;
  maloprid.mnDest;
  mnUZac.mnDest;
  close (datUporab);
  clrscr;
end.